//+------------------------------------------------------------------+
//|                                                       sakera.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+

extern int MMType = 1;
extern bool UseClose = FALSE;
extern bool UseAdd = TRUE;
extern double LotExponent = 1.667;
extern double slip = 3.0;
extern double Lots = 0.1;
extern double LotsDigits = 2.0;
extern double TakeProfit = 4.0;
double g_pips_128 = 0.0;
double gd_136 = 0.0;
double gd_144 = 0.0;
extern double PipStep = 3.0;
extern int MaxTrades = 100;
extern bool UseEquityStop = FALSE;
extern double TotalEquityRisk = 10.0;
extern bool UseTrailingStop = FALSE;
extern bool UseTimeOut = FALSE;
extern double MaxTradeOpenHours = 0.0;
extern string MODALTHARIAN = "Jika target dengan set TRUE maka set profit_akhir anda, misal: modal awal $100, jika anda ingin mendapatkan perharinya $10, maka set TARGETMARGIN :110";
extern bool Target = false;
extern double profit_akhir = 100.0;
extern string JamTrading = "Menentukan jam trading";
extern bool UseHourTrade = FALSE;
extern int StartHour = 22;
extern int EndHour = 5;
int g_magic_192 = 12324;
double g_price_196;
double gd_204;
double gd_unused_212;
double gd_unused_220;
double g_price_228;
double g_bid_236;
double g_ask_244;
double gd_252;
double gd_260;
double gd_268;
bool gi_276;
string gs_280 = "Madiun-Fx";
int g_time_288 = 0;
int gi_292;
int gi_296 = 0;
double gd_300;
int g_pos_308 = 0;
int gi_312;
double gd_316 = 0.0;
bool gi_324 = TRUE;
bool gi_328 = TRUE;
bool gi_332 = TRUE;
int gi_336;
bool gi_340 = TRUE;
int g_datetime_344 = 0;
int g_datetime_348 = 0;
double gd_352;
double gd_360;
double gd_428;

int init() {
   gd_268 = MarketInfo(Symbol(), MODE_SPREAD) * Point;
   gd_428 = AccountBalance();
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double order_lots_0;
   double order_lots_8;
   double iclose_16;
   double iclose_24;
  
  Comment("MARGIN_ANDA : ", DoubleToStr(AccountEquity(), 4), 
      "\nMODAL AWAL    : ", DoubleToStr(gd_428, 4), 
   "\nLOTS                 : " + DoubleToStr(OrderLots(), 2),
   "\nIngat jangan serakah..., ");
  
  
   int li_32 = 59121;
   int acc_number_36 = AccountNumber();
   if (acc_number_36 != li_32) {
      Alert("You can not use this account (" + DoubleToStr(acc_number_36, 0) + ") with this program!");
      return (0);
   }

   if (Target) {

      if (AccountEquity() > profit_akhir) {
         f0_4();
         Comment("Target profit telah tercapai!");
         return (0);
       } 

   }
   
   
   if (UseHourTrade) {
      if (!(Hour() >= StartHour && Hour() <= EndHour)) {
         f0_4();
         Comment("Non-Trading Hours!");
         return (0);
      }
   }
   
   
   
   
   if (UseTrailingStop) f0_11(gd_136, gd_144, g_price_228);
   if (UseTimeOut) {
      if (TimeCurrent() >= gi_292) {
         f0_4();
         Print("Closed All due to TimeOut");
      }
   }
   if (g_time_288 == Time[0]) return (0);
   g_time_288 = Time[0];
   double ld_32 = f0_10();
   if (UseEquityStop) {
      if (ld_32 < 0.0 && MathAbs(ld_32) > TotalEquityRisk / 100.0 * f0_12()) {
         f0_4();
         Print("Closed All due to Stop Out");
         gi_340 = FALSE;
      }
   }
   gi_312 = f0_3();
   if (gi_312 == 0) gi_276 = FALSE;
   for (g_pos_308 = OrdersTotal() - 1; g_pos_308 >= 0; g_pos_308--) {
      OrderSelect(g_pos_308, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) {
         if (OrderType() == OP_BUY) {
            gi_328 = TRUE;
            gi_332 = FALSE;
            order_lots_0 = OrderLots();
            break;
         }
      }
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) {
         if (OrderType() == OP_SELL) {
            gi_328 = FALSE;
            gi_332 = TRUE;
            order_lots_8 = OrderLots();
            break;
         }
      }
   }
   if (gi_312 > 0 && gi_312 <= MaxTrades) {
      RefreshRates();
      gd_252 = f0_13();
      gd_260 = f0_14();
      if (gi_328 && gd_252 - Ask >= PipStep * Point) gi_324 = TRUE;
      if (gi_332 && Bid - gd_260 >= PipStep * Point) gi_324 = TRUE;
   }
   if (gi_312 < 1) {
      gi_332 = FALSE;
      gi_328 = FALSE;
      gi_324 = TRUE;
      gd_204 = AccountEquity();
   }
   if (gi_324) {
      gd_252 = f0_13();
      gd_260 = f0_14();
      if (gi_332) {
         if (UseClose) {
            f0_1(0, 1);
            gd_300 = NormalizeDouble(LotExponent * order_lots_8, LotsDigits);
         } else gd_300 = f0_2(OP_SELL);
         if (UseAdd) {
            gi_296 = gi_312;
            if (gd_300 > 0.0) {
               RefreshRates();
               gi_336 = f0_5(1, gd_300, Bid, slip, Ask, 0, 0, gs_280 + "-" + gi_296, g_magic_192, 0, HotPink);
               if (gi_336 < 0) {
                  Print("Error: ", GetLastError());
                  return (0);
               }
               gd_260 = f0_14();
               gi_324 = FALSE;
               gi_340 = TRUE;
            }
         }
      } else {
         if (gi_328) {
            if (UseClose) {
               f0_1(1, 0);
               gd_300 = NormalizeDouble(LotExponent * order_lots_0, LotsDigits);
            } else gd_300 = f0_2(OP_BUY);
            if (UseAdd) {
               gi_296 = gi_312;
               if (gd_300 > 0.0) {
                  gi_336 = f0_5(0, gd_300, Ask, slip, Bid, 0, 0, gs_280 + "-" + gi_296, g_magic_192, 0, Lime);
                  if (gi_336 < 0) {
                     Print("Error: ", GetLastError());
                     return (0);
                  }
                  gd_252 = f0_13();
                  gi_324 = FALSE;
                  gi_340 = TRUE;
               }
            }
         }
      }
   }
   if (gi_324 && gi_312 < 1) {
      iclose_16 = iClose(Symbol(), 0, 2);
      iclose_24 = iClose(Symbol(), 0, 1);
      g_bid_236 = Bid;
      g_ask_244 = Ask;
      if ((!gi_332) && !gi_328) {
         gi_296 = gi_312;
         if (iclose_16 > iclose_24) {
            gd_300 = f0_2(OP_SELL);
            if (gd_300 > 0.0) {
               gi_336 = f0_5(1, gd_300, g_bid_236, slip, g_bid_236, 0, 0, gs_280 + "-" + gi_296, g_magic_192, 0, HotPink);
               if (gi_336 < 0) {
                  Print(gd_300, "Error: ", GetLastError());
                  return (0);
               }
               gd_252 = f0_13();
               gi_340 = TRUE;
            }
         } else {
            gd_300 = f0_2(OP_BUY);
            if (gd_300 > 0.0) {
               gi_336 = f0_5(0, gd_300, g_ask_244, slip, g_ask_244, 0, 0, gs_280 + "-" + gi_296, g_magic_192, 0, Lime);
               if (gi_336 < 0) {
                  Print(gd_300, "Error: ", GetLastError());
                  return (0);
               }
               gd_260 = f0_14();
               gi_340 = TRUE;
            }
         }
      }
      if (gi_336 > 0) gi_292 = TimeCurrent() + 60.0 * (60.0 * MaxTradeOpenHours);
      gi_324 = FALSE;
   }
   gi_312 = f0_3();
   g_price_228 = 0;
   double ld_40 = 0;
   for (g_pos_308 = OrdersTotal() - 1; g_pos_308 >= 0; g_pos_308--) {
      OrderSelect(g_pos_308, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) {
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) {
            g_price_228 += OrderOpenPrice() * OrderLots();
            ld_40 += OrderLots();
         }
      }
   }
   if (gi_312 > 0) g_price_228 = NormalizeDouble(g_price_228 / ld_40, Digits);
   if (gi_340) {
      for (g_pos_308 = OrdersTotal() - 1; g_pos_308 >= 0; g_pos_308--) {
         OrderSelect(g_pos_308, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) {
            if (OrderType() == OP_BUY) {
               g_price_196 = g_price_228 + TakeProfit * Point;
               gd_unused_212 = g_price_196;
               gd_316 = g_price_228 - g_pips_128 * Point;
               gi_276 = TRUE;
            }
         }
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) {
            if (OrderType() == OP_SELL) {
               g_price_196 = g_price_228 - TakeProfit * Point;
               gd_unused_220 = g_price_196;
               gd_316 = g_price_228 + g_pips_128 * Point;
               gi_276 = TRUE;
            }
         }
      }
   }
   if (gi_340) {
      if (gi_276 == TRUE) {
         for (g_pos_308 = OrdersTotal() - 1; g_pos_308 >= 0; g_pos_308--) {
            OrderSelect(g_pos_308, SELECT_BY_POS, MODE_TRADES);
            if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) OrderModify(OrderTicket(), g_price_228, OrderStopLoss(), g_price_196, 0, Yellow);
            gi_340 = FALSE;
         }
      }
   }
   return (0);
}

double f0_0 (double ad_0) {
   return (NormalizeDouble(ad_0, Digits));
}

int f0_1(bool ai_0 = TRUE, bool ai_4 = TRUE) {
   int li_ret_8 = 0;
   for (int pos_12 = OrdersTotal() - 1; pos_12 >= 0; pos_12--) {
      if (OrderSelect(pos_12, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) {
            if (OrderType() == OP_BUY && ai_0) {
               RefreshRates();
               if (!IsTradeContextBusy()) {
                  if (!OrderClose(OrderTicket(), OrderLots(), f0_0(Bid), 5, CLR_NONE)) {
                     Print("Error close BUY " + OrderTicket());
                     li_ret_8 = -1;
                  }
               } else {
                  if (g_datetime_344 != iTime(NULL, 0, 0)) {
                     g_datetime_344 = iTime(NULL, 0, 0);
                     Print("Need close BUY " + OrderTicket() + ". Trade Context Busy");
                  }
                  return (-2);
               }
            }
            if (OrderType() == OP_SELL && ai_4) {
               RefreshRates();
               if (!IsTradeContextBusy()) {
                  if (!((!OrderClose(OrderTicket(), OrderLots(), f0_0(Ask), 5, CLR_NONE)))) continue;
                  Print("Error close SELL " + OrderTicket());
                  li_ret_8 = -1;
                  continue;
               }
               if (g_datetime_348 != iTime(NULL, 0, 0)) {
                  g_datetime_348 = iTime(NULL, 0, 0);
                  Print("Need close SELL " + OrderTicket() + ". Trade Context Busy");
               }
               return (-2);
            }
         }
      }
   }
   return (li_ret_8);
}

double f0_2(int a_cmd_0) {
   double lots_4;
   int datetime_12;
   switch (MMType) {
   case 0:
      lots_4 = Lots;
      break;
   case 1:
      lots_4 = NormalizeDouble(Lots * MathPow(LotExponent, gi_296), LotsDigits);
      break;
   case 2:
      datetime_12 = 0;
      lots_4 = Lots;
      for (int pos_20 = OrdersHistoryTotal() - 1; pos_20 >= 0; pos_20--) {
         if (OrderSelect(pos_20, SELECT_BY_POS, MODE_HISTORY)) {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) {
               if (datetime_12 < OrderCloseTime()) {
                  datetime_12 = OrderCloseTime();
                  if (OrderProfit() < 0.0) {
                     lots_4 = NormalizeDouble(OrderLots() * LotExponent, LotsDigits);
                     continue;
                  }
                  lots_4 = Lots;
               }
            }
         } else return (-3);
      }
   }
   if (AccountFreeMarginCheck(Symbol(), a_cmd_0, lots_4) <= 0.0) return (-1);
   if (GetLastError() == 134/* NOT_ENOUGH_MONEY */) return (-2);
   return (lots_4);
}

int f0_3() {
   int count_0 = 0;
   for (int pos_4 = OrdersTotal() - 1; pos_4 >= 0; pos_4--) {
      OrderSelect(pos_4, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192)
         if (OrderType() == OP_SELL || OrderType() == OP_BUY) count_0++;
   }
   return (count_0);
}

void f0_4() {
   for (int pos_0 = OrdersTotal() - 1; pos_0 >= 0; pos_0--) {
      OrderSelect(pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192) {
            if (OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), Bid, slip, Blue);
            if (OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), Ask, slip, Red);
         }
         Sleep(1000);
      }
   }
}

int f0_5(int ai_0, double a_lots_4, double a_price_12, int a_slippage_20, double ad_24, int ai_32, int ai_36, string a_comment_40, int a_magic_48, int a_datetime_52, color a_color_56) {
   int ticket_60 = 0;
   int error_64 = 0;
   int count_68 = 0;
   int li_72 = 100;
   switch (ai_0) {
   case 2:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_BUYLIMIT, a_lots_4, a_price_12, a_slippage_20, f0_6(ad_24, ai_32), f0_8(a_price_12, ai_36), a_comment_40, a_magic_48, a_datetime_52,
            a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(1000);
      }
      break;
   case 4:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_BUYSTOP, a_lots_4, a_price_12, a_slippage_20, f0_6(ad_24, ai_32), f0_8(a_price_12, ai_36), a_comment_40, a_magic_48, a_datetime_52,
            a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 0:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         RefreshRates();
         ticket_60 = OrderSend(Symbol(), OP_BUY, a_lots_4, Ask, a_slippage_20, f0_6(Bid, ai_32), f0_8(Ask, ai_36), a_comment_40, a_magic_48, a_datetime_52, a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 3:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_SELLLIMIT, a_lots_4, a_price_12, a_slippage_20, f0_7(ad_24, ai_32), f0_9(a_price_12, ai_36), a_comment_40, a_magic_48, a_datetime_52,
            a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 5:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_SELLSTOP, a_lots_4, a_price_12, a_slippage_20, f0_7(ad_24, ai_32), f0_9(a_price_12, ai_36), a_comment_40, a_magic_48, a_datetime_52,
            a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 1:
      for (count_68 = 0; count_68 < li_72; count_68++) {
         ticket_60 = OrderSend(Symbol(), OP_SELL, a_lots_4, Bid, a_slippage_20, f0_7(Ask, ai_32), f0_9(Bid, ai_36), a_comment_40, a_magic_48, a_datetime_52, a_color_56);
         error_64 = GetLastError();
         if (error_64 == 0/* NO_ERROR */) break;
         if (!((error_64 == 4/* SERVER_BUSY */ || error_64 == 137/* BROKER_BUSY */ || error_64 == 146/* TRADE_CONTEXT_BUSY */ || error_64 == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
   }
   return (ticket_60);
}

double f0_6(double ad_0, int ai_8) {
   if (ai_8 == 0) return (0);
   return (ad_0 - ai_8 * Point);
}

double f0_7(double ad_0, int ai_8) {
   if (ai_8 == 0) return (0);
   return (ad_0 + ai_8 * Point);
}

double f0_8(double ad_0, int ai_8) {
   if (ai_8 == 0) return (0);
   return (ad_0 + ai_8 * Point);
}

double f0_9(double ad_0, int ai_8) {
   if (ai_8 == 0) return (0);
   return (ad_0 - ai_8 * Point);
}

double f0_10() {
   double ld_ret_0 = 0;
   for (g_pos_308 = OrdersTotal() - 1; g_pos_308 >= 0; g_pos_308--) {
      OrderSelect(g_pos_308, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192)
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) ld_ret_0 += OrderProfit();
   }
   return (ld_ret_0);
}

void f0_11(int ai_0, int ai_4, double a_price_8) {
   int li_16;
   double order_stoploss_20;
   double price_28;
   if (ai_4 != 0) {
      for (int pos_36 = OrdersTotal() - 1; pos_36 >= 0; pos_36--) {
         if (OrderSelect(pos_36, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
            if (OrderSymbol() == Symbol() || OrderMagicNumber() == g_magic_192) {
               if (OrderType() == OP_BUY) {
                  li_16 = NormalizeDouble((Bid - a_price_8) / Point, 0);
                  if (li_16 < ai_0) continue;
                  order_stoploss_20 = OrderStopLoss();
                  price_28 = Bid - ai_4 * Point;
                  if (order_stoploss_20 == 0.0 || (order_stoploss_20 != 0.0 && price_28 > order_stoploss_20)) OrderModify(OrderTicket(), a_price_8, price_28, OrderTakeProfit(), 0, Aqua);
               }
               if (OrderType() == OP_SELL) {
                  li_16 = NormalizeDouble((a_price_8 - Ask) / Point, 0);
                  if (li_16 < ai_0) continue;
                  order_stoploss_20 = OrderStopLoss();
                  price_28 = Ask + ai_4 * Point;
                  if (order_stoploss_20 == 0.0 || (order_stoploss_20 != 0.0 && price_28 < order_stoploss_20)) OrderModify(OrderTicket(), a_price_8, price_28, OrderTakeProfit(), 0, Red);
               }
            }
            Sleep(1000);
         }
      }
   }
}

double f0_12() {
   if (f0_3() == 0) gd_352 = AccountEquity();
   if (gd_352 < gd_360) gd_352 = gd_360;
   else gd_352 = AccountEquity();
   gd_360 = AccountEquity();
   return (gd_352);
}

double f0_13() {
   double order_open_price_0;
   int ticket_8;
   double ld_unused_12 = 0;
   int ticket_20 = 0;
   for (int pos_24 = OrdersTotal() - 1; pos_24 >= 0; pos_24--) {
      OrderSelect(pos_24, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192 && OrderType() == OP_BUY) {
         ticket_8 = OrderTicket();
         if (ticket_8 > ticket_20) {
            order_open_price_0 = OrderOpenPrice();
            ld_unused_12 = order_open_price_0;
            ticket_20 = ticket_8;
         }
      }
   }
   return (order_open_price_0);
}

double f0_14() {
   double order_open_price_0;
   int ticket_8;
   double ld_unused_12 = 0;
   int ticket_20 = 0;
   for (int pos_24 = OrdersTotal() - 1; pos_24 >= 0; pos_24--) {
      OrderSelect(pos_24, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_192) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_192 && OrderType() == OP_SELL) {
         ticket_8 = OrderTicket();
         if (ticket_8 > ticket_20) {
            order_open_price_0 = OrderOpenPrice();
            ld_unused_12 = order_open_price_0;
            ticket_20 = ticket_8;
         }
      }
   }
   return (order_open_price_0);
}